package de.bsvrz.vew.bmvew.bmvew.regel;

import de.bsvrz.dav.daf.main.Data.TextArray;
import de.bsvrz.dav.daf.main.Data.TextValue;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.SenderRole;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sys.funclib.debug.Debug;
import de.bsvrz.vew.bmvew.bmvew.BetriebsMeldungApp;
import de.bsvrz.vew.bmvew.bmvew.sender.Sender;

/**
 * Die Klasse implementiert das Ausfuehr-Verhalten Senden 
 *
 * @version $Revision: 1.1 $ / $Date: 2009/09/24 12:50:46 $ / ($Author: Pittner $)
 *
 * @author Dambach-Werke GmbH
 * @author Timo Pittner
 *
 */
public class AusfuehrenSenden implements AktionAusfuehrVerhalten
{
  /**
   * Der Debugger
   */
  Debug _debug;

  /**
   * Das Feld der Parametertexte
   */
  TextArray _parameter;

  /**
   * Der Aktionstext
   */
  TextValue _aktion;

  /**
   * @param parameter
   *          Feld der Parametertexte
   * @param aktion
   *          Aktionstext
   */
  public AusfuehrenSenden(TextArray parameter, TextValue aktion)
  {
    // TODO Auto-generated constructor stub
    if (aktion == null || parameter == null)
      throw new IllegalArgumentException();
    
    _parameter = parameter;
    _aktion = aktion;
    _debug = Debug.getLogger();
  }

  /* (non-Javadoc)
   * @see de.bsvrz.vew.bmvew.bmvew.regel.AktionAusfuehrVerhalten#ausfuehrenAktion(de.bsvrz.dav.daf.main.ResultData)
   */
  public boolean ausfuehrenAktion(ResultData betriebsMeldung)
  {
    // TODO Auto-generated method stub
    for (int i = 0; i < _parameter.getLength(); i++)
    {
      String text = _parameter.getText(i);

      SystemObject object = BetriebsMeldungApp.getConnection().getDataModel().getObject(text);

      if (object == null || !object.isOfType("typ.betriebsMeldungsVerwaltung"))
      {
        final String errorMessage = "Es gibt kein passendes BetriebsMeldungsVerwaltungs-Objekt: " + text;
        _debug.error(errorMessage);
        return false;
      }
      
      _debug.fine("Aktion -> " + _aktion.getText() + " sende an BetriebsMeldungsVerwaltung: " + object.getPid());
      
      Sender sender = new Sender(BetriebsMeldungApp.getConnection(), SenderRole.sender());
      DataDescription dd = betriebsMeldung.getDataDescription();
      sender.sende(object, dd.getAttributeGroup(), dd.getAspect(), betriebsMeldung.getData());

//      
//      ResultData resultData = new ResultData(object, betriebsMeldung.getDataDescription(), betriebsMeldung
//          .getDataTime(), betriebsMeldung.getData());
//
//      try
//      {
//        _debug.fine("Aktion -> " + _aktion.getText() + " sende an BetriebsMeldungsVerwaltung: " + object.getPid());
//        BetriebsMeldungApp.getConnection().sendData(resultData);
//        
//      }
//      catch (DataNotSubscribedException e)
//      {
//        // TODO Auto-generated catch block
//        e.printStackTrace();
//      }
//      catch (SendSubscriptionNotConfirmed e)
//      {
//        // TODO Auto-generated catch block
//        e.printStackTrace();
//      }
    }

    return true;
  }

}
